"{ Package: 'stx:libbasic3' }"

VersionInfo subclass:#CVSVersionInfo
	instanceVariableNames:'repositoryPathName timeZone state'
	classVariableNames:''
	poolDictionaries:''
	category:'System-SourceCodeManagement'
!

!CVSVersionInfo class methodsFor:'documentation'!

documentation
"
    Class used to return a Dictionary when asked for versionInfo.
    This has been replaced by instances of VersionInfo and subclasses.

    Notice, that CVSVersionInfo adds some CVS specific data.

    [author:]
        cg (cg@AQUA-DUO)
"
! !

!CVSVersionInfo class methodsFor:'instance creation'!

fromRCSString:aString
    "{ Pragma: +optSpace }"

    "I know how to parse RCS/CVS version id strings.
     Return an instance filled with revision info which is
     extracted from aString. This must be in RCS/CVS format."

    |words firstWord nextWord info nm|

    words := aString asCollectionOfWords readStream.

    words atEnd ifTrue:[^ nil].

    info := self new.

    "/
    "/ supported formats:
    "/
    "/ $-Header:   pathName rev date time user state $
    "/ $-Revision: rev $
    "/ $-Id:       fileName rev date time user state $
    "/
    firstWord := words next.
    (firstWord = '$Header:') ifTrue:[
        nm := words next.
        info repositoryPathName:nm.
        (nm endsWith:',v') ifTrue:[
            nm := nm copyWithoutLast:2
        ].
        info fileName:nm asFilename baseName.
        words atEnd ifFalse:[
            nextWord := words next.
            nextWord ~= '$' ifTrue:[
                info revision:nextWord.
                nextWord := words next.
                nextWord ~= '$' ifTrue:[
                    info date:nextWord.
                    info time:words next.
                    nextWord := words next.
                    (nextWord startsWithAnyOf:'+-') ifTrue:[
                        info timezone:nextWord.
                        nextWord := words next.
                    ].
                    info user:nextWord.
                    info state:words next.
                ]
            ].
        ].
        ^ info
    ].

    (firstWord = '$Revision:') ifTrue:[
        info revision:words next.
        ^ info
    ].

    (firstWord = '$Id:') ifTrue:[
        info fileName:(words next).
        info revision:(words next).
        info date:(words next).
        info time:(words next).
        info user:(words next).
        info state:(words next).
        ^ info
    ].

    ^ nil

    "
     CVSVersionInfo fromRCSString:('$' , 'Revision: 1.122 $')
     CVSVersionInfo fromRCSString:(SourceCodeManager version)
    "

    "Modified: / 22-10-2008 / 20:17:00 / cg"
! !

!CVSVersionInfo methodsFor:'accessing'!

repositoryPathName
    ^ repositoryPathName
!

repositoryPathName:something
    repositoryPathName := something.
!

state
    ^ state
!

state:something
    state := something.
!

timeZone
    ^ timeZone
!

timeZone:something
    timeZone := something.
!

timezone
    ^ timeZone

    "Created: / 22-10-2008 / 20:50:39 / cg"
!

timezone:something
    timeZone := something.

    "Created: / 22-10-2008 / 20:50:32 / cg"
! !

!CVSVersionInfo class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/CVSVersionInfo.st,v 1.1 2008-10-22 18:54:52 cg Exp $'
! !
